package examen2014_2015;

import histogram.*;
import java.util.Locale;

/**
 * Esta clase se da hecha para probar el código generado.
 * 
 * Se realizan cuatro pruebas que podrán pasarse por separado si se comentan a mano las lineas que se quieran anular
 * <code>
 * <br><br>
 * checkOK(datos, basic);<br>
 * checkOK(datos, module);<br>
 * checkERROR(datos, basic);<br>
 * checkERROR(datos, module);<br>
 * </code>
 * 
 */
public class Examen2014_2015 {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        BinCounter[] basic={new BasicBinCounter(), new BasicCumulativeLRBinCounter(), new BasicCumulativeRLBinCounter()};
        BinCounter[] module={new ModuleBinCounter(), new ModuleCumulativeLRBinCounter(), new ModuleCumulativeRLBinCounter()};
        
        double[] datos=new double[25];
        for (int i=0;i<datos.length;i++) datos[i]=2*Math.random()-0.5;
        for (int i=0;i<datos.length;i++) System.out.printf("%.2f%c",datos[i],((i+1)%5==0?'\n':'\t'));
        
        checkOK(datos, basic);
        checkOK(datos, module);
        checkERROR(datos, basic);
        checkERROR(datos, module);
    }
 
    
    static void checkOK(double[] datos, BinCounter[] binCounters){
        double[] bins;
        if (binCounters[0] instanceof BasicBinCounter) bins = new double[]{-.1,.1,.2,.3,.4,.5};
        else bins = new double[]{.1,.2,.3,.4,.5};
        for (BinCounter bc:binCounters) {
            bc.calculateBinCounts(bins, datos);
            
            System.out.println(bc.getClass().getName());
            System.out.println(bc.countsToText());
            System.out.println("--------------------------");
        }
    }

      static void checkERROR(double[] datos, BinCounter[] binCounters){
        double[] bins={-.1,-.1,.2,.3,.4,.5};
        for (BinCounter bc:binCounters) {
            try {
            bc.calculateBinCounts(bins, datos);
            System.out.println(bc.getClass().getName()+" debería generar una excepción y no lo hace. (los bins no están ordenados)" );
            } catch (Exception ex) {
                System.out.println(bc.getClass().getName()+" genera correctamente una excepción. Mensaje: "+ex.getMessage());
            }
        }
        if (binCounters[0] instanceof BasicBinCounter) return;
        bins=new double[]{-.1,.2,.3,.4,.5};
        for (BinCounter bc:binCounters) {
            try {
            bc.calculateBinCounts(bins, datos);
            System.out.println(bc.getClass().getName()+" debería generar una excepción y no lo hace. (se le ha dado un bin negativo)" );
            } catch (Exception ex) {
                System.out.println(bc.getClass().getName()+" genera correctamente una excepción. Mensaje: "+ex.getMessage());
            }
        }
    }
}
